# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DataShare::Mgmt::V2019_11_01
  module Models
    #
    # A Invitation data transfer object.
    #
    class Invitation < ProxyDto

      include MsRestAzure

      # @return [String] unique invitation id
      attr_accessor :invitation_id

      # @return [InvitationStatus] The status of the invitation. Possible
      # values include: 'Pending', 'Accepted', 'Rejected', 'Withdrawn'
      attr_accessor :invitation_status

      # @return [DateTime] The time the recipient responded to the invitation.
      attr_accessor :responded_at

      # @return [DateTime] Gets the time at which the invitation was sent.
      attr_accessor :sent_at

      # @return [String] The target Azure AD Id. Can't be combined with email.
      attr_accessor :target_active_directory_id

      # @return [String] The email the invitation is directed to.
      attr_accessor :target_email

      # @return [String] The target user or application Id that invitation is
      # being sent to.
      # Must be specified along TargetActiveDirectoryId. This enables sending
      # invitations to specific users or applications in an AD tenant.
      attr_accessor :target_object_id

      # @return [String] Email of the user who created the resource
      attr_accessor :user_email

      # @return [String] Name of the user who created the resource
      attr_accessor :user_name


      #
      # Mapper for Invitation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Invitation',
          type: {
            name: 'Composite',
            class_name: 'Invitation',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              invitation_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.invitationId',
                type: {
                  name: 'String'
                }
              },
              invitation_status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.invitationStatus',
                type: {
                  name: 'String'
                }
              },
              responded_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.respondedAt',
                type: {
                  name: 'DateTime'
                }
              },
              sent_at: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.sentAt',
                type: {
                  name: 'DateTime'
                }
              },
              target_active_directory_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.targetActiveDirectoryId',
                type: {
                  name: 'String'
                }
              },
              target_email: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.targetEmail',
                type: {
                  name: 'String'
                }
              },
              target_object_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.targetObjectId',
                type: {
                  name: 'String'
                }
              },
              user_email: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.userEmail',
                type: {
                  name: 'String'
                }
              },
              user_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.userName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
